<?php
/* here are the lines you must add to the 2 search.php files
**
** 1. add to the lib/CTRL/search.php
*/

/* ADD */  use Joomla\CMS\Factory; // just before use Sobi\Input\Input;

class SPSearchCtrl extends SPSectionCtrl  // excisting class name
{
// in
protected function search()
    {

// 1. AFTER: $this->_request = SPRequest::search( 'field_' );  (1st or 2nd line)
    /* -----    new for radius search ------------ */
        $this->_request[ 'search_type' ] = Input::String('submit_search', 'request');

        if ($this->_request[ 'search_type' ] == 'radius') {
        $this->_request[ 'radiuscity' ] = Input::String( 'sp_radius_city','request');
        $this->_request[ 'radiusdist' ] = Input::Int( 'sp_radius_select','request' );
        } else {
/* -----    END for radius search ------------ just before this 3 lines */
            // $this->_request[ 'search_for' ] = ' .....';
            // $this->_request[ 'phrase' ] = '....';
            // $this->_request[ 'phrase' ] = '....';
        }   //NEW   DON'T forget to add this close bracket for the else'

// 2. AFTER: (v1.4) usort( $this->_fields, [ 'self', 'sortByPrio' ] );
   //    OR  (v1.5)  $this->session( $ssid, false );   }

/* first the radius_search - if we have a string to search */
    if ( $this->_request[ 'search_type' ] == "radius" && strlen( $this->_request[ 'radiuscity' ] ) && $this->_request[ 'radiuscity' ] != Sobi::Txt( 'SH.SEARCH_FOR_DIST' ) )
    {
         $db =  Factory::getDBO();
         $section = Sobi::Section();
         $field_ghash = (int)Sobi::Cfg( 'radius.field_ghash' );
            if (!$field_ghash)
                $field_ghash = "(select min(f2.fid) from #__sobipro_field f2 where f2.nid like '%ghash%' and f2.section = $section and f2.fieldType = 'inbox' and f2.enabled = 1)";
         $field_city = (int)Sobi::Cfg( 'radius.field_city' );
                if (!$field_city)
                $field_city = "(select min(f1.fid) from #__sobipro_field f1 where f1.nid like '%field_city%' and f1.section = $section and f1.fieldType = 'inbox' and f1.enabled = 1)";

            $service_key = Sobi::Cfg( 'radius.service_key','' ); // loc-service from config

            if (empty(trim($service_key))) {
                $service = 'nomin';
            }
            elseif (Sobi::Cfg( 'radius.service',0 )) {
                $service = 'ocage';
            }
            else {
                $service = 'lociq';
            }

            // if entry is an ID, not a city name
        if (ctype_digit($this->_request[ 'radiuscity' ]))
        {
            $radcity_id = (int)$this->_request[ 'radiuscity' ];
                                /* sobi version, but internal the same
            $this->_request['ghashcity'] = $this->_db->select('baseData', 'spdb_field_data', [ 'section' => Sobi::Section(), '!baseData' => NULL, 'fid' => $field_city, 'sid' => $radcity_id, 'enabled' => 1] )
                                                     ->loadResult();                                                                                                     // '!baseData' => null,
            $this->_request[ 'radiuscity' ] = $this->_db->select('baseData', 'spdb_field_data', [ 'section' => Sobi::Section(), '!baseData' => NULL, 'fid' => $field_city, 'sid' => $radcity_id, 'enabled' => 1] )
                                                     ->loadResult(); */

            $query = "select fd.baseData as ghash, (select fc.baseData from #__sobipro_field_data fc where fc.fid = $field_city and fc.section = $section and fc.sid = $radcity_id) as city from #__sobipro_field_data fd where fd.fid = $field_ghash and fd.sid = $radcity_id and fd.section = $section";

                $db->setQuery($query);
                $res_db = $db->loadObject();

            if(empty($res_db) && Sobi::Cfg( 'radius.plz_de' ) && strlen($radcity_id) == 5 ) {    //try geoloc with german PLZ
                unset($res_db);
                    $lociq = $this->geoloc($radcity_id.',Deutschland',$service,$service_key);
                if ($lociq['results'][0]['components']['_type'] != 'postcode')
                $res_db = false;
            }
            elseif (!$res_db->ghash) {    // no geohash found
                if (!$res_db->city) {     // no city name found
                    $res_db = false;     // will cause Error
                } else {
                    unset($res_db);
                    $lociq = $this->geoloc($res_db->city,$service,$service_key); //lookup with city name
                }
            }

        } else {   // no item ID
            $lociq = $this->geoloc($this->_request[ 'radiuscity' ],$service,$service_key);
        }

         if (isset($res_db) && !$res_db) {  // no data in database
            $this->_results = 0;
            $rancor = '#errormes';          // result ancor  - not needed urgently
            $this->_request[ 'result' ] = 'error';

            SPFactory::message()->error( Sobi::Txt( 'SH.SEARCH_HASH_ERROR', ['id' => $radcity_id] ));

         } else {

         if (isset($res_db) && $res_db) {     //ghash & city from db
            $this->_request[ 'ghashcity' ] =  $res_db->ghash;
            $this->_request[ 'radiuscity' ] = $res_db->city;
         } else {                             //ghash & city from lociq
            if ($service == 'ocage') {
                $cityname = (isset($lociq['results'][0]['components']['city'])) ? $lociq['results'][0]['components']['city'] :(($lociq['results'][0]['components']['county']) ? $lociq['results'][0]['components']['county'] : explode(',',$lociq['results'][0]['formatted'])[0]);
                $this->_request[ 'ghashcity' ] =  $lociq['results'][0]['annotations']['geohash'];
            }
            else {  // if lociq or nomatim
                $cityname = (isset($lociq[0]['address']['city'])) ? $lociq[0]['address']['city'] :(($lociq[0]['address']['county']) ? $lociq[0]['address']['county'] : explode(',',$lociq[0]['display_name'])[0]);  //(locationiq) $lociq[0]['address']['city'] - $lociq[0]['address']['county'] - explode(',',$lociq[0]['display_name'])[0];
                $this->_request[ 'ghashcity' ] =  $this->ghashenc($lociq[0]['lat'],$lociq[0]['lon']);  // encode ghash using lat-lon
           }

           $this->_request[ 'radiuscity' ] = ($cityname) ? $cityname : $this->_request[ 'radiuscity' ];
         }

         //now get the entries within distance limit
         $earth = (Sobi::Cfg( 'radius.unit',0 )) ? 6371 : 3959;  //fix: earth in km or miles
         $query = "SELECT sid, ROUND( ST_Distance_Sphere (ST_PointFromGeoHash('{$this->_request[ 'ghashcity' ]}',0),ST_PointFromGeoHash(baseData,0), {$earth} ) ) AS km FROM #__sobipro_field_data WHERE fid = $field_ghash AND enabled = 1 AND basedata <> '' AND section = $section HAVING km <= {$this->_request[ 'radiusdist' ]} ORDER BY km";

         $rancor = '#SPDistSearch';
         $this->_results = [];
         $this->_request['distance'] = [];
         $this->_request['db'] = [];
         $db->setQuery($query);
         $dbr = $db->loadAssocList();

         $this->_results = array_column($dbr, 'sid');
         $this->_request['db'] = $this->_results;
         $this->_request['distance'] = array_combine(array_column($dbr, 'sid'),array_column($dbr, 'km'));

        }
        $this->_resultsByPriority[1] = $this->_results;
        Sobi::Trigger( 'AfterBasic', 'Search', [ &$this->_results, &$this->_resultsByPriority ] );
    }


/* ------------ END radius search --------------- */
// next ....basic search ....
// IMPORTANT !!! RENAME:  if -> elseif
// AFTER 3rd line ( $this->_narrowing = true; ) add
   $rancor = '#SPSearchBox';   // this is just a result ancor - not needed urgently

/*!!!!!!!!!!!!!!!!! this line is important !!!!!!!!!!!!!!*/
/*new*/ if ( $this->_request[ 'search_type' ] != "radius") // !!!!!!!! just before:
     // $this->_request[ 'search_for' ] = str_replace( '%', '*', $this->_request[ 'search_for' ] );

// before the last line add this ancor (if you want - not needed)
/*new*/ $ancor = (isset($rancor)) ? $rancor : '#SPSearchForm'; // just a result ancor
// and edit the last line Sobi::Redirect( Sobi::Url( $url ) );  to
        Sobi::Redirect( Sobi::Url( $url ).$ancor  );
}

// in
protected function sortPriority()  // v 1.4x  -- OR
protected function sortResults( $mainOrder, $fields = [] ) // v 1.5x   ADD
    {
   /* -----    new: distance order for radius search ------------ */
                            if ($this->_request[ 'search_type' ] == "radius") {
                            //filter distance array by priority
                            $this->_request['distance'] = array_intersect_key( $this->_request['distance'], array_flip( $this->_resultsByPriority[ 1 ] ) );
                            // set results with distance order
                            $this->_results = array_keys($this->_request['distance']);
                            //unsorted:  $this->_results = $this->_resultsByPriority[ 1 ];
                            }
                            else
/* -----    end distance order for radius search ------------ */
// just before this line: (near end in v1.4  or  before::  no second order 18.9.2019 in v1.5
                 /*old*/    $this->_results = array_merge( $this->_results, $this->_resultsByPriority[ $prio ] );
}
// in
protected function form()  // add after
    {
    /*    if ( isset( $this->_request[ 'search_for' ] ) ) {
            $view->assign( $this->_request[ 'search_for' ], 'search_for' )
                ->assign( $this->_request[ 'phrase' ], 'search_phrase' );
        }
------ new for radius search ------  */
        if ( isset( $this->_request[ 'radiuscity' ] )) {
            $view->assign( $this->_request[ 'radiuscity' ], 'radius_city' )
                 ->assign( $this->_request[ 'radiusdist' ], 'radius_select' )
                 ->assign( $this->_request[ 'distance' ],'dist_val');
            }
        $view->assign( $this->_request[ 'search_type' ],'searchtype' );
/* end for radius search */


}
/* ---somewhere at the end add the new geodata functions !!!!!! ------------------- */

        protected function geoloc($city,$service = 'lociq',$key) {

        $USERAGENT = $_SERVER['HTTP_USER_AGENT'];
        $opts = array('https'=>array('method'=>"GET",'header'=>"User-Agent: $USERAGENT\r\n"));
        $context = stream_context_create($opts);

        if (!$key) {
            $service = 'nomin';
        }
        switch ($service) {
        case 'nomin':
        $geoj = file_get_contents('http://nominatim.openstreetmap.org/?format=json&addressdetails=1&q='.urlencode($city).'&format=json&limit=1',false,$context);
        break;
        case 'ocage':                                                                                 //95ac456dbad340bd82fe43daae8f66e8
        $geoj = file_get_contents('https://api.opencagedata.com/geocode/v1/json?q='.urlencode($city).'&key='.$key.'&limit=1&language=de',false,$context);
        break;
        case 'lociq':
        default:                                                             //672df394b6e287
        $geoj = file_get_contents('https://eu1.locationiq.com/v1/search.php?key='.$key.'&q='.urlencode($city).'&addressdetails=1&format=json');
        break;
        }
        $geodata = json_decode($geoj, true);
        if ($geodata) {
        return $geodata;    //loca+nom: $geodata[0]['lat']  $geodata[0]['lon'];  $geodata[0]['address']['city']; $geodata[0]['address']['county']; explode(',',$geodata[0]['display_name'])[0];
        } else {            //opencage: $geodata['results'][0]['geometry']['lat'];  $geodata['results'][0]['geometry']['lng'];
        return false;       //   "      $geodata['results'][0]['annotations']['geohash']; $geodata['results'][0]['components']['city']; $geodata['results'][0]['components']['county']; explode(',',$geodata['results'][0]['fotmatted'])[0];
        }
        }

        public function ghashenc($lat, $lng, $prec = null)
    {
        $table = "0123456789bcdefghjkmnpqrstuvwxyz";
        $bits = array(16, 8, 4, 2, 1);

        $lap = strlen($lat) - strpos($lat, ".");
        $lop = strlen($lng) - strpos($lng, ".");
        $prec = $prec ?: pow(10, -max($lap-1, $lop-1, 0))/2;
        $minlng = -180;
        $maxlng = 180;
        $minlat = -90;
        $maxlat = 90;

        $hash = array();
        $error = 180;
        $isEven = true;
        $chr = 0;
        $b = 0;

        while ($error >= $prec) {
            if ($isEven) {
                $next = ($minlng + $maxlng) / 2;
                if ($lng > $next) {
                    $chr |= $bits[$b]; //$this->$bits[$b];
                    $minlng = $next;
                } else {
                    $maxlng = $next;
                }
            } else {
                $next = ($minlat + $maxlat) / 2;
                if ($lat > $next) {
                    $chr |= $bits[$b]; //$this->$bits[$b];
                    $minlat = $next;
                } else {
                    $maxlat = $next;
                }
            }
            $isEven = !$isEven;

            if ($b < 4) {
                $b++;
            } else {
 /*!!!!*/       $hash[] = $table[$chr]; //$this->$table[$chr];
                $error = max($maxlng - $minlng, $maxlat - $minlat);
                $b = 0;
                $chr = 0;
            }
        }

        return join('', $hash);
    }
}



/*
** 2. add to the lib/VIEWS/search.php
*/
class SPSearchView extends SPSectionView implements SPView  // excisting class name
{
//in
public function display( $type = 'section', $out = null )
	{
// AFTER    $searchPhrase = $this->get( 'search_for' );
//			$phrase = $this->get( 'search_phrase' );
//			$searchPhrase = strlen( $searchPhrase ) ? $searchPhrase : Sobi::Txt( 'SH.SEARCH_FOR_BOX' );

/* new for radius search ---------------------------- */
            $searchDist = $this->get( 'radius_select' );
            $searchCity = $this->get( 'radius_city' );
            $searchCity = strlen( $searchCity ) ? ucfirst($searchCity) : Sobi::Txt( 'SH.SEARCH_FOR_DIST' );
/* end for radius search ---------------------------- */

// AFTER  if ( $this->get( '$eCount' ) >= 0 ) {  (v1.4)  OR  (v1.5) if ( $scount >= 0 ) {  add:
// just for str declaration if single or multi results
                $m = ($this->get( '$eCount' ) <> 1) ? Sobi::Txt('SH.MULTICHAR') : '';
                $searchWord = ($searchPhrase == Sobi::Txt( 'SH.SEARCH_FOR_BOX' )) ? Sobi::Txt( 'SH.SEARCH_FILTER' ) : $searchPhrase;


/*--- result message for error, radius or basic --------*/
// AFTER   (v1.4) $searchData[ 'message' ] ==

               ( $this->get( 'searchtype' ) == 'radius' ) ?
               (($this->get( 'db_results' ) == 'error') ?
                'ERROR. '. Sobi::Txt( 'SH.SEARCH_HASH_ERROR', ['id' => $this->get('radius_city')] )
                 : Sobi::Txt('SH.SEARCH_FOUND_DISTRESULTS', [ 'multi' => $m, 'count' => $this->get( '$eCount' ), 'city' => $searchCity,'dist' => $searchDist]))
                 : Sobi::Txt( 'SH.SEARCH_FOUND_RESULTS', [ 'multi' => $m, 'count' => $this->get( '$eCount' ), 'word' => $searchWord ] );

// OR       (v1.5) $sterm = $this->get( 'search_for' );

                if ( $this->get( 'searchtype' ) == 'radius' ) {
                if ($this->get( 'db_results' ) == 'error')
                $searchData[ 'message' ] = 'ERROR. '. Sobi::Txt( 'SH.SEARCH_HASH_ERROR', ['id' => $this->get('radius_city')] );
                else
                   $searchData[ 'message' ] = Sobi::Txt('SH.SEARCH_FOUND_DISTRESULTS', [ 'multi' => $m, 'count' => $scount, 'city' => $searchCity,'dist' => $searchDist]) ;
                }

//  in the next $searchData[ 'message' ] = lines just add the multi-variable 'multi' => $m, at the beginning of the array like in the line above
//  in the last line add the $searchword variable also (only, if you want see it in the message)
 /*like this*/  $searchData[ 'message' ] = Sobi::Txt( 'SH.SEARCH_FOUND_RESULTS', [ 'multi' => $m, 'count' => $scount, 'word' => $searchWord ] );


/* ------- this is for the new radius-search container ------------------- */
// add these line just BEFORE:  if ( count( $fields ) ) {

            if ( Sobi::Cfg( 'search.radius', true ) ) {
                        $fData[ 'radiusbox' ] = [
            					'_complex'    => 1,
            					'_data'       => [
            						'label' => [
            							'_complex'    => 1,
            							'_data'       => Sobi::Txt( 'SH.SEARCH_DIST' ),
            							'_attributes' => [ 'lang' => Sobi::Lang( false ) ],
            						],
            						'data'  => [
                                    	'_complex' => 1,
            							'_xml'     => 1,
                                    	'_data'    => SPHtml_Input::text( 'sp_radius_city', $searchCity, [ 'class' => Sobi::Cfg( 'search.form_box_def_css', 'SPSearchBox' ), 'id' => 'SPRadiusCity' ] ),
                                        ],
            					],
            					'_attributes' => [ 'position' => 1, 'css_class' => 'SPSearchBox' ],
            				];

                        $unit =  (Sobi::Cfg( 'radius.unit',0 )) ? 'km' : 'mi';

                        $fData[ 'radiusdist' ] = [
            					'_complex'    => 1,
            					'_data'       => [
            						'label' => [
            							'_complex'    => 1,
            							'_data'       => Sobi::Txt( 'SH.FIND_ENTRIES_WITHIN' ),
            							'_attributes' => [ 'lang' => Sobi::Lang( false ) ],
            						],
            						'data'  => [
            							'_complex' => 1,
            							'_xml'     => 1,
            							'_data'    => SPHtml_Input::select(
            								'sp_radius_select',
            								[
            									5    => '&emsp;5 '.$unit,
            									10   => '&ensp;10 '.$unit,
            									25   => '&ensp;25 '.$unit,
                                                50   => '&ensp;50 '.$unit,
            									100  => '100 '.$unit,
            									150  => '150 '.$unit,
                                                200  => '200 '.$unit,
                                                250  => '250 '.$unit,
            								],
                                            $searchDist,
                                            false,
                                            null ),
            						],
            					],
            					'_attributes' => [ 'position' => 1, 'css_class' => 'SPField form-control inputbox' ],
            				];

                        $fData[ 'radius_button' ] = [
            					'_complex'    => 1,
            					'_data'       => [
            						'label' => [
            							'_complex'    => 1,
            							'_data'       => Sobi::Txt( 'SH.SEARCH_START' ),
            							'_attributes' => [ 'lang' => Sobi::Lang( false ) ],
            						],
            						'data'  => [
            							'_complex' => 1,
            							'_xml'     => 1,
            							'_data'    => SPHtml_Input::submit( 'search', Sobi::Txt( 'SH.RADSTART' ), [ 'id' => 'rad_button' ] ),
            						],
            					],
            					'_attributes' => [ 'position' => 1, 'css_class' => 'SPSearchButton' ],
            				];
            }
/* ------- END new radius-search container ------------------- */

// the next (last :) is optional - it enables the section entry in the category field to easyly clear the selection
// not needed for radius search - it enables the section (with value "") in the cat. dropdown, so it can be used as deselect option
                    if ($field->get( 'type' ) == 'category') {
                    $fData[ $field->get( 'nid' ) ]['_data']['data']['_data'] = preg_replace('/disabled="disabled" value="\d*/','value="',$data);
                    }
                    // end of this new block
// just add this lines BEFORE: (3 brackets) } } }  if ( Sobi::Cfg( 'search.bottom_button', false ) ) {

}

/* ----- END ----- enough to do :) ------- */

}
?>