<!-- edit the view.xsl in usr/yourtemplate/search folder: -->

<!-- 1. (if you want) -- set the message template in an div, just as an  ancor -->
        <div id="errormes">
        <xsl:apply-templates select="messages"/>
        </div>

<!-- 2. (if you want) -- just a line with add. user informations -->
<!-- AFTER   <div id="SPSearchForm" class="form-horizontal">  ADD -->
        <div class="SPExtHint"><xsl:value-of select="php:function( 'SobiPro::Txt', 'SH.SEARCH_EXTHINT' )" /></div>

<!-- 3. (if you want - better html/js) - NEW JS script required, add data-attributes to the extended search button  -->
        <button type="button" class="btn btn-default extended-search" name="SPExOptBt" id="SPExOptBt">
            <xsl:attribute name="data-text-rad">
                <xsl:value-of select="php:function( 'SobiPro::Txt', 'SH.SEARCH_DIST' )" />
            </xsl:attribute>
            <xsl:variable name="data-ext">
                <xsl:value-of select="php:function( 'SobiPro::Txt', 'EXTENDED_SEARCH' )" />
            </xsl:variable>
            <xsl:attribute name="data-text-ext">
                <xsl:value-of select="$data-ext" />
            </xsl:attribute>
            <xsl:value-of select="$data-ext" />
        </button>

<!-- 4. (if you want) reset string for the extended filters - NEW JS script required -->
        <div id="resetExtSearch" class="exreset">
            <xsl:variable name="exbtn">
                <xsl:value-of select="php:function( 'SobiPro::Txt', 'SH.SEARCH_EXTRESET_BTN' )" />
            </xsl:variable>
            <xsl:attribute name="title">
                <xsl:value-of select="php:function( 'SobiPro::Txt', 'SH.SEARCH_EXTRESET_TT' )" />
            </xsl:attribute>
            <xsl:attribute name="data-text-reset">
                <xsl:value-of select="$exbtn" />
            </xsl:attribute>
            <xsl:attribute name="data-text-deleted">
                <xsl:value-of select="php:function( 'SobiPro::Txt', 'SH.SEARCH_EXTRESET_OK' )" />
            </xsl:attribute>
            <xsl:value-of select="$exbtn" />
        </div>

<!-- 5. IMPORTANT the radius search field  -->

<!-- ADD BEFORE the extSearch block   <xsl:if test="count( /search/fields/* ) &gt; 3">
                ....
                <xsl:attribute name="id">SPExtSearch - near the end -->

                <xsl:if test="/search/fields/radiusbox">
                    <div id="SPDistSearch" class="control-group group-dist">
                        <label class="control-label" for="SPRadius">
                            <span class="badge badge-new"><xsl:value-of select="php:function( 'SobiPro::Txt', 'SH.NEW' )" /></span><br />
                            <xsl:value-of select="/search/fields/radiusbox/label" />
                            <img src="/images/sobipro/rsearchg.png" class ="ico-rsearch" alt="" />
                        </label>
                        <div class="controls sp-search-controls sp-dist">
                            <xsl:variable name="ctitle"><xsl:value-of select="php:function( 'SobiPro::Txt', 'SH.RADCENT' )" /></xsl:variable>
                            <xsl:variable name="defrad"><xsl:value-of select="php:function( 'SobiPro::Txt', 'SH.SEARCH_FOR_DIST' )" /></xsl:variable>
                            <xsl:variable name="fdesc"><xsl:value-of select="php:function( 'SobiPro::Txt', 'SH.SEARCH_FIELDS' )" /></xsl:variable>
                            <span class="sp-dist-field"><xsl:value-of select="$fdesc" /></span><br />
                            <input type="text" id="SPRadius" name="sp_radius_city" value="{/search/fields/radiusbox/data/input/@value}" class="input-medium" title="{$ctitle}" data-text-rad="{$defrad}" />
                        <xsl:if test="/search/fields/radiusdist">
                            <xsl:variable name="dtitle"><xsl:value-of select="/search/fields/radiusdist/label" /></xsl:variable>
                            <select id="SpSelectDist" name="sp_radius_select" class="spClassSelect SPSearchSelect form-control select-small" title="{$dtitle}" >
                            <xsl:for-each select="/search/fields/radiusdist/data/select/option">
                                <option value="{@value}">
                                    <xsl:if test="@selected='selected'">
                                        <xsl:attribute name="selected">selected</xsl:attribute>
                                    </xsl:if>
                                <xsl:value-of select="." />
                                </option>
                            </xsl:for-each>
                            </select>
                        </xsl:if>

                        <xsl:if test="/search/fields/radius_button/label">
                                <button type="submit" name="submit_search" value="radius" class="btn btn-success btn-dist">
                                    <xsl:value-of select="/search/fields/radius_button/label" />
                                </button>
                        </xsl:if>
                        <br /><span class="dishint"><xsl:value-of select="php:function( 'SobiPro::Txt', 'SH.SEARCH_DISHINT' )" /></span>
                        </div>
                    </div>
                </xsl:if>
<!-- END radius search field  -->

<!-- if you want the distance to be displayed in the vcard -->
<!-- edit the vcard.xsl in usr/yourtemplate/common folder: -->
<!-- just after the h2 tag in page header or where you need/want it -->
<xsl:if test="string-length(@km)" >
            <div class="vcdist">
            <span class="badge badge-info"><xsl:value-of select="@km" /></span><small><xsl:value-of select="@unit" /></small>
            </div>
        </xsl:if>